//#line 2 "/opt/ros/kinetic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"
// *********************************************************
//
// File autogenerated for the cis_camera package
// by the dynamic_reconfigure package.
// Please do not edit.
//
// ********************************************************/

#ifndef __cis_camera__CISCAMERACONFIG_H__
#define __cis_camera__CISCAMERACONFIG_H__

#if __cplusplus >= 201103L
#define DYNAMIC_RECONFIGURE_FINAL final
#else
#define DYNAMIC_RECONFIGURE_FINAL
#endif

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/Group.h>
#include <dynamic_reconfigure/config_init_mutex.h>
#include <boost/any.hpp>

namespace cis_camera
{
  class CISCameraConfigStatics;

  class CISCameraConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l,
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }

      virtual void clamp(CISCameraConfig &config, const CISCameraConfig &max, const CISCameraConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const CISCameraConfig &config1, const CISCameraConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, CISCameraConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const CISCameraConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, CISCameraConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const CISCameraConfig &config) const = 0;
      virtual void getValue(const CISCameraConfig &config, boost::any &val) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template <class T>
    class ParamDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string a_name, std::string a_type, uint32_t a_level,
          std::string a_description, std::string a_edit_method, T CISCameraConfig::* a_f) :
        AbstractParamDescription(a_name, a_type, a_level, a_description, a_edit_method),
        field(a_f)
      {}

      T (CISCameraConfig::* field);

      virtual void clamp(CISCameraConfig &config, const CISCameraConfig &max, const CISCameraConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;

        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const CISCameraConfig &config1, const CISCameraConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, CISCameraConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const CISCameraConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, CISCameraConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const CISCameraConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }

      virtual void getValue(const CISCameraConfig &config, boost::any &val) const
      {
        val = config.*field;
      }
    };

    class AbstractGroupDescription : public dynamic_reconfigure::Group
    {
      public:
      AbstractGroupDescription(std::string n, std::string t, int p, int i, bool s)
      {
        name = n;
        type = t;
        parent = p;
        state = s;
        id = i;
      }

      std::vector<AbstractParamDescriptionConstPtr> abstract_parameters;
      bool state;

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &config) const =0;
      virtual void updateParams(boost::any &cfg, CISCameraConfig &top) const= 0;
      virtual void setInitialState(boost::any &cfg) const = 0;


      void convertParams()
      {
        for(std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = abstract_parameters.begin(); i != abstract_parameters.end(); ++i)
        {
          parameters.push_back(dynamic_reconfigure::ParamDescription(**i));
        }
      }
    };

    typedef boost::shared_ptr<AbstractGroupDescription> AbstractGroupDescriptionPtr;
    typedef boost::shared_ptr<const AbstractGroupDescription> AbstractGroupDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template<class T, class PT>
    class GroupDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractGroupDescription
    {
    public:
      GroupDescription(std::string a_name, std::string a_type, int a_parent, int a_id, bool a_s, T PT::* a_f) : AbstractGroupDescription(a_name, a_type, a_parent, a_id, a_s), field(a_f)
      {
      }

      GroupDescription(const GroupDescription<T, PT>& g): AbstractGroupDescription(g.name, g.type, g.parent, g.id, g.state), field(g.field), groups(g.groups)
      {
        parameters = g.parameters;
        abstract_parameters = g.abstract_parameters;
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        if(!dynamic_reconfigure::ConfigTools::getGroupState(msg, name, (*config).*field))
          return false;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          if(!(*i)->fromMessage(msg, n))
            return false;
        }

        return true;
      }

      virtual void setInitialState(boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        T* group = &((*config).*field);
        group->state = state;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = boost::any(&((*config).*field));
          (*i)->setInitialState(n);
        }

      }

      virtual void updateParams(boost::any &cfg, CISCameraConfig &top) const
      {
        PT* config = boost::any_cast<PT*>(cfg);

        T* f = &((*config).*field);
        f->setParams(top, abstract_parameters);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          (*i)->updateParams(n, top);
        }
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &cfg) const
      {
        const PT config = boost::any_cast<PT>(cfg);
        dynamic_reconfigure::ConfigTools::appendGroup<T>(msg, name, id, parent, config.*field);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          (*i)->toMessage(msg, config.*field);
        }
      }

      T (PT::* field);
      std::vector<CISCameraConfig::AbstractGroupDescriptionConstPtr> groups;
    };

class DEFAULT
{
  public:
    DEFAULT()
    {
      state = true;
      name = "Default";
    }

    void setParams(CISCameraConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);


      }
    }

    

    bool state;
    std::string name;

    class DEPTH_IR_PARAMETERS_ON_CAMERA_HARDWARE
{
  public:
    DEPTH_IR_PARAMETERS_ON_CAMERA_HARDWARE()
    {
      state = true;
      name = "Depth_IR_Parameters_on_Camera_Hardware";
    }

    void setParams(CISCameraConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("depth_range"==(*_i)->name){depth_range = boost::any_cast<int>(val);}
        if("nr_filter"==(*_i)->name){nr_filter = boost::any_cast<int>(val);}
        if("threshold"==(*_i)->name){threshold = boost::any_cast<int>(val);}
        if("pulse_count"==(*_i)->name){pulse_count = boost::any_cast<int>(val);}
        if("ld_enable"==(*_i)->name){ld_enable = boost::any_cast<int>(val);}
        if("ir_gain"==(*_i)->name){ir_gain = boost::any_cast<int>(val);}
      }
    }

    int depth_range;
int nr_filter;
int threshold;
int pulse_count;
int ld_enable;
int ir_gain;

    bool state;
    std::string name;

    
}depth_ir_parameters_on_camera_hardware;

class RGB_PARAMETERS_ON_CAMERA_HARDWARE
{
  public:
    RGB_PARAMETERS_ON_CAMERA_HARDWARE()
    {
      state = true;
      name = "RGB_Parameters_on_Camera_Hardware";
    }

    void setParams(CISCameraConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("ae_mode"==(*_i)->name){ae_mode = boost::any_cast<int>(val);}
        if("color_correction"==(*_i)->name){color_correction = boost::any_cast<int>(val);}
        if("brightness_gain"==(*_i)->name){brightness_gain = boost::any_cast<double>(val);}
        if("exposure_time"==(*_i)->name){exposure_time = boost::any_cast<double>(val);}
      }
    }

    int ae_mode;
int color_correction;
double brightness_gain;
double exposure_time;

    bool state;
    std::string name;

    
}rgb_parameters_on_camera_hardware;

class DEPTH_IR_CAMERA_DISTORTION_CORRECTION_ON_DRIVER_SOFTWARE
{
  public:
    DEPTH_IR_CAMERA_DISTORTION_CORRECTION_ON_DRIVER_SOFTWARE()
    {
      state = true;
      name = "Depth_IR_Camera_Distortion_Correction_on_Driver_Software";
    }

    void setParams(CISCameraConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("ir_dist_reconfig"==(*_i)->name){ir_dist_reconfig = boost::any_cast<bool>(val);}
        if("ir_fx"==(*_i)->name){ir_fx = boost::any_cast<double>(val);}
        if("ir_fy"==(*_i)->name){ir_fy = boost::any_cast<double>(val);}
        if("ir_cx"==(*_i)->name){ir_cx = boost::any_cast<double>(val);}
        if("ir_cy"==(*_i)->name){ir_cy = boost::any_cast<double>(val);}
        if("ir_k1"==(*_i)->name){ir_k1 = boost::any_cast<double>(val);}
        if("ir_k2"==(*_i)->name){ir_k2 = boost::any_cast<double>(val);}
        if("ir_k3"==(*_i)->name){ir_k3 = boost::any_cast<double>(val);}
        if("ir_p1"==(*_i)->name){ir_p1 = boost::any_cast<double>(val);}
        if("ir_p2"==(*_i)->name){ir_p2 = boost::any_cast<double>(val);}
      }
    }

    bool ir_dist_reconfig;
double ir_fx;
double ir_fy;
double ir_cx;
double ir_cy;
double ir_k1;
double ir_k2;
double ir_k3;
double ir_p1;
double ir_p2;

    bool state;
    std::string name;

    
}depth_ir_camera_distortion_correction_on_driver_software;

class RGB_CAMERA_COLOR_GAINS_ON_DRIVER_SOFTWARE
{
  public:
    RGB_CAMERA_COLOR_GAINS_ON_DRIVER_SOFTWARE()
    {
      state = true;
      name = "RGB_Camera_Color_Gains_on_Driver_Software";
    }

    void setParams(CISCameraConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("r_gain"==(*_i)->name){r_gain = boost::any_cast<double>(val);}
        if("g_gain"==(*_i)->name){g_gain = boost::any_cast<double>(val);}
        if("b_gain"==(*_i)->name){b_gain = boost::any_cast<double>(val);}
      }
    }

    double r_gain;
double g_gain;
double b_gain;

    bool state;
    std::string name;

    
}rgb_camera_color_gains_on_driver_software;

class RGB_CAMERA_DISTORTION_CORRECTION_ON_DRIVER_SOFTWARE
{
  public:
    RGB_CAMERA_DISTORTION_CORRECTION_ON_DRIVER_SOFTWARE()
    {
      state = true;
      name = "RGB_Camera_Distortion_Correction_on_Driver_Software";
    }

    void setParams(CISCameraConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("rgb_dist_reconfig"==(*_i)->name){rgb_dist_reconfig = boost::any_cast<bool>(val);}
        if("rgb_fx"==(*_i)->name){rgb_fx = boost::any_cast<double>(val);}
        if("rgb_fy"==(*_i)->name){rgb_fy = boost::any_cast<double>(val);}
        if("rgb_cx"==(*_i)->name){rgb_cx = boost::any_cast<double>(val);}
        if("rgb_cy"==(*_i)->name){rgb_cy = boost::any_cast<double>(val);}
        if("rgb_k1"==(*_i)->name){rgb_k1 = boost::any_cast<double>(val);}
        if("rgb_k2"==(*_i)->name){rgb_k2 = boost::any_cast<double>(val);}
        if("rgb_k3"==(*_i)->name){rgb_k3 = boost::any_cast<double>(val);}
        if("rgb_p1"==(*_i)->name){rgb_p1 = boost::any_cast<double>(val);}
        if("rgb_p2"==(*_i)->name){rgb_p2 = boost::any_cast<double>(val);}
      }
    }

    bool rgb_dist_reconfig;
double rgb_fx;
double rgb_fy;
double rgb_cx;
double rgb_cy;
double rgb_k1;
double rgb_k2;
double rgb_k3;
double rgb_p1;
double rgb_p2;

    bool state;
    std::string name;

    
}rgb_camera_distortion_correction_on_driver_software;

}groups;



//#line 18 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      int depth_range;
//#line 23 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      int nr_filter;
//#line 25 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      int threshold;
//#line 27 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      int pulse_count;
//#line 29 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      int ld_enable;
//#line 31 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      int ir_gain;
//#line 40 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      int ae_mode;
//#line 45 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      int color_correction;
//#line 47 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double brightness_gain;
//#line 49 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double exposure_time;
//#line 52 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      bool ir_dist_reconfig;
//#line 53 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double ir_fx;
//#line 54 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double ir_fy;
//#line 55 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double ir_cx;
//#line 56 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double ir_cy;
//#line 57 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double ir_k1;
//#line 58 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double ir_k2;
//#line 59 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double ir_k3;
//#line 60 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double ir_p1;
//#line 61 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double ir_p2;
//#line 64 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double r_gain;
//#line 65 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double g_gain;
//#line 66 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double b_gain;
//#line 69 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      bool rgb_dist_reconfig;
//#line 70 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double rgb_fx;
//#line 71 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double rgb_fy;
//#line 72 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double rgb_cx;
//#line 73 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double rgb_cy;
//#line 74 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double rgb_k1;
//#line 75 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double rgb_k2;
//#line 76 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double rgb_k3;
//#line 77 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double rgb_p1;
//#line 78 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      double rgb_p2;
//#line 228 "/opt/ros/kinetic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();

      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        if ((*i)->fromMessage(msg, *this))
          count++;

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i ++)
      {
        if ((*i)->id == 0)
        {
          boost::any n = boost::any(this);
          (*i)->updateParams(n, *this);
          (*i)->fromMessage(msg, n);
        }
      }

      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("CISCameraConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__, const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toMessage(msg, *this);

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        if((*i)->id == 0)
        {
          (*i)->toMessage(msg, *this);
        }
      }
    }

    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      __toMessage__(msg, __param_descriptions__, __group_descriptions__);
    }

    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      static bool setup=false;

      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->fromServer(nh, *this);

      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++){
        if (!setup && (*i)->id == 0) {
          setup = true;
          boost::any n = boost::any(this);
          (*i)->setInitialState(n);
        }
      }
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const CISCameraConfig &__max__ = __getMax__();
      const CISCameraConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const CISCameraConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->calcLevel(level, config, *this);
      return level;
    }

    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const CISCameraConfig &__getDefault__();
    static const CISCameraConfig &__getMax__();
    static const CISCameraConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    static const std::vector<AbstractGroupDescriptionConstPtr> &__getGroupDescriptions__();

  private:
    static const CISCameraConfigStatics *__get_statics__();
  };

  template <> // Max and min are ignored for strings.
  inline void CISCameraConfig::ParamDescription<std::string>::clamp(CISCameraConfig &config, const CISCameraConfig &max, const CISCameraConfig &min) const
  {
    (void) config;
    (void) min;
    (void) max;
    return;
  }

  class CISCameraConfigStatics
  {
    friend class CISCameraConfig;

    CISCameraConfigStatics()
    {
CISCameraConfig::GroupDescription<CISCameraConfig::DEFAULT, CISCameraConfig> Default("Default", "", 0, 0, true, &CISCameraConfig::groups);
CISCameraConfig::GroupDescription<CISCameraConfig::DEFAULT::DEPTH_IR_PARAMETERS_ON_CAMERA_HARDWARE, CISCameraConfig::DEFAULT> Depth_IR_Parameters_on_Camera_Hardware("Depth_IR_Parameters_on_Camera_Hardware", "", 0, 1, true, &CISCameraConfig::DEFAULT::depth_ir_parameters_on_camera_hardware);
//#line 18 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.depth_range = 0;
//#line 18 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.depth_range = 1;
//#line 18 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.depth_range = 0;
//#line 18 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      Depth_IR_Parameters_on_Camera_Hardware.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<int>("depth_range", "int", 0, "Depth Range 0:Range0 1:Range1", "{'enum_description': 'An enum to set depth_range', 'enum': [{'srcline': 13, 'description': 'Range: 0', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'Range_0'}, {'srcline': 14, 'description': 'Range: 1', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'Range_1'}]}", &CISCameraConfig::depth_range)));
//#line 18 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<int>("depth_range", "int", 0, "Depth Range 0:Range0 1:Range1", "{'enum_description': 'An enum to set depth_range', 'enum': [{'srcline': 13, 'description': 'Range: 0', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'Range_0'}, {'srcline': 14, 'description': 'Range: 1', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'Range_1'}]}", &CISCameraConfig::depth_range)));
//#line 23 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.nr_filter = 0;
//#line 23 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.nr_filter = 1;
//#line 23 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.nr_filter = 1;
//#line 23 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      Depth_IR_Parameters_on_Camera_Hardware.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<int>("nr_filter", "int", 0, "Noise Reduction Filter", "{'enum_description': 'An enum to set NR filter', 'enum': [{'srcline': 19, 'description': 'Noise Reduction Filter: Off', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'NR_Off'}, {'srcline': 20, 'description': 'Noise Reduction Filter: On', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'NR_On'}]}", &CISCameraConfig::nr_filter)));
//#line 23 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<int>("nr_filter", "int", 0, "Noise Reduction Filter", "{'enum_description': 'An enum to set NR filter', 'enum': [{'srcline': 19, 'description': 'Noise Reduction Filter: Off', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'NR_Off'}, {'srcline': 20, 'description': 'Noise Reduction Filter: On', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'NR_On'}]}", &CISCameraConfig::nr_filter)));
//#line 25 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.threshold = 0;
//#line 25 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.threshold = 1023;
//#line 25 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.threshold = 0;
//#line 25 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      Depth_IR_Parameters_on_Camera_Hardware.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<int>("threshold", "int", 0, "Corering Threshold Unit:[mm]", "", &CISCameraConfig::threshold)));
//#line 25 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<int>("threshold", "int", 0, "Corering Threshold Unit:[mm]", "", &CISCameraConfig::threshold)));
//#line 27 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.pulse_count = 0;
//#line 27 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.pulse_count = 2000;
//#line 27 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.pulse_count = 2000;
//#line 27 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      Depth_IR_Parameters_on_Camera_Hardware.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<int>("pulse_count", "int", 0, "Pulse Count", "", &CISCameraConfig::pulse_count)));
//#line 27 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<int>("pulse_count", "int", 0, "Pulse Count", "", &CISCameraConfig::pulse_count)));
//#line 29 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.ld_enable = 0;
//#line 29 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.ld_enable = 3;
//#line 29 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.ld_enable = 3;
//#line 29 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      Depth_IR_Parameters_on_Camera_Hardware.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<int>("ld_enable", "int", 0, "Laser Diode Enable 0:LD1&2-OFF 1:LD1-ON 2:LD2-ON 3:LD1&2-ON", "", &CISCameraConfig::ld_enable)));
//#line 29 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<int>("ld_enable", "int", 0, "Laser Diode Enable 0:LD1&2-OFF 1:LD1-ON 2:LD2-ON 3:LD1&2-ON", "", &CISCameraConfig::ld_enable)));
//#line 31 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.ir_gain = 0;
//#line 31 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.ir_gain = 2047;
//#line 31 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.ir_gain = 256;
//#line 31 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      Depth_IR_Parameters_on_Camera_Hardware.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<int>("ir_gain", "int", 0, "IR Gain", "", &CISCameraConfig::ir_gain)));
//#line 31 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<int>("ir_gain", "int", 0, "IR Gain", "", &CISCameraConfig::ir_gain)));
//#line 124 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Depth_IR_Parameters_on_Camera_Hardware.convertParams();
//#line 124 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.groups.push_back(CISCameraConfig::AbstractGroupDescriptionConstPtr(new CISCameraConfig::GroupDescription<CISCameraConfig::DEFAULT::DEPTH_IR_PARAMETERS_ON_CAMERA_HARDWARE, CISCameraConfig::DEFAULT>(Depth_IR_Parameters_on_Camera_Hardware)));
//#line 124 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(CISCameraConfig::AbstractGroupDescriptionConstPtr(new CISCameraConfig::GroupDescription<CISCameraConfig::DEFAULT::DEPTH_IR_PARAMETERS_ON_CAMERA_HARDWARE, CISCameraConfig::DEFAULT>(Depth_IR_Parameters_on_Camera_Hardware)));
CISCameraConfig::GroupDescription<CISCameraConfig::DEFAULT::RGB_PARAMETERS_ON_CAMERA_HARDWARE, CISCameraConfig::DEFAULT> RGB_Parameters_on_Camera_Hardware("RGB_Parameters_on_Camera_Hardware", "", 0, 2, true, &CISCameraConfig::DEFAULT::rgb_parameters_on_camera_hardware);
//#line 40 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.ae_mode = 0;
//#line 40 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.ae_mode = 3;
//#line 40 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.ae_mode = 3;
//#line 40 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      RGB_Parameters_on_Camera_Hardware.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<int>("ae_mode", "int", 0, "RGB Auto Exposure Mode", "{'enum_description': 'An enum to set ae_mode', 'enum': [{'srcline': 34, 'description': 'Manual', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'Manual'}, {'srcline': 35, 'description': 'Auto: Gain', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'Auto_Gain'}, {'srcline': 36, 'description': 'Auto: Shutter', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'Auto_Shutter'}, {'srcline': 37, 'description': 'Auto: Full', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 3, 'ctype': 'int', 'type': 'int', 'name': 'Auto_Full'}]}", &CISCameraConfig::ae_mode)));
//#line 40 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<int>("ae_mode", "int", 0, "RGB Auto Exposure Mode", "{'enum_description': 'An enum to set ae_mode', 'enum': [{'srcline': 34, 'description': 'Manual', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'Manual'}, {'srcline': 35, 'description': 'Auto: Gain', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'Auto_Gain'}, {'srcline': 36, 'description': 'Auto: Shutter', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'Auto_Shutter'}, {'srcline': 37, 'description': 'Auto: Full', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 3, 'ctype': 'int', 'type': 'int', 'name': 'Auto_Full'}]}", &CISCameraConfig::ae_mode)));
//#line 45 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.color_correction = 0;
//#line 45 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.color_correction = 1;
//#line 45 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.color_correction = 1;
//#line 45 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      RGB_Parameters_on_Camera_Hardware.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<int>("color_correction", "int", 0, "Color Correction Mode", "{'enum_description': 'An enum to set color_correction', 'enum': [{'srcline': 41, 'description': 'Off', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'Off'}, {'srcline': 42, 'description': 'Standard', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'Standard'}]}", &CISCameraConfig::color_correction)));
//#line 45 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<int>("color_correction", "int", 0, "Color Correction Mode", "{'enum_description': 'An enum to set color_correction', 'enum': [{'srcline': 41, 'description': 'Off', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'Off'}, {'srcline': 42, 'description': 'Standard', 'srcfile': '/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'Standard'}]}", &CISCameraConfig::color_correction)));
//#line 47 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.brightness_gain = 1.0;
//#line 47 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.brightness_gain = 10.67;
//#line 47 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.brightness_gain = 1.0;
//#line 47 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      RGB_Parameters_on_Camera_Hardware.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("brightness_gain", "double", 0, "RGB Brightness Gain", "", &CISCameraConfig::brightness_gain)));
//#line 47 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("brightness_gain", "double", 0, "RGB Brightness Gain", "", &CISCameraConfig::brightness_gain)));
//#line 49 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.exposure_time = 1e-05;
//#line 49 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.exposure_time = 0.01;
//#line 49 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.exposure_time = 0.01;
//#line 49 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      RGB_Parameters_on_Camera_Hardware.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("exposure_time", "double", 0, "RGB Exposure Time (Shutter Control)", "", &CISCameraConfig::exposure_time)));
//#line 49 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("exposure_time", "double", 0, "RGB Exposure Time (Shutter Control)", "", &CISCameraConfig::exposure_time)));
//#line 124 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      RGB_Parameters_on_Camera_Hardware.convertParams();
//#line 124 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.groups.push_back(CISCameraConfig::AbstractGroupDescriptionConstPtr(new CISCameraConfig::GroupDescription<CISCameraConfig::DEFAULT::RGB_PARAMETERS_ON_CAMERA_HARDWARE, CISCameraConfig::DEFAULT>(RGB_Parameters_on_Camera_Hardware)));
//#line 124 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(CISCameraConfig::AbstractGroupDescriptionConstPtr(new CISCameraConfig::GroupDescription<CISCameraConfig::DEFAULT::RGB_PARAMETERS_ON_CAMERA_HARDWARE, CISCameraConfig::DEFAULT>(RGB_Parameters_on_Camera_Hardware)));
CISCameraConfig::GroupDescription<CISCameraConfig::DEFAULT::DEPTH_IR_CAMERA_DISTORTION_CORRECTION_ON_DRIVER_SOFTWARE, CISCameraConfig::DEFAULT> Depth_IR_Camera_Distortion_Correction_on_Driver_Software("Depth_IR_Camera_Distortion_Correction_on_Driver_Software", "", 0, 3, true, &CISCameraConfig::DEFAULT::depth_ir_camera_distortion_correction_on_driver_software);
//#line 52 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.ir_dist_reconfig = 0;
//#line 52 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.ir_dist_reconfig = 1;
//#line 52 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.ir_dist_reconfig = 0;
//#line 52 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      Depth_IR_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<bool>("ir_dist_reconfig", "bool", 0, "IR/Depth Camera Distortion Correction Reconfigure", "", &CISCameraConfig::ir_dist_reconfig)));
//#line 52 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<bool>("ir_dist_reconfig", "bool", 0, "IR/Depth Camera Distortion Correction Reconfigure", "", &CISCameraConfig::ir_dist_reconfig)));
//#line 53 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.ir_fx = 100.0;
//#line 53 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.ir_fx = 500.0;
//#line 53 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.ir_fx = 390.0;
//#line 53 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      Depth_IR_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("ir_fx", "double", 0, "IR/Depth Camera Fx", "", &CISCameraConfig::ir_fx)));
//#line 53 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("ir_fx", "double", 0, "IR/Depth Camera Fx", "", &CISCameraConfig::ir_fx)));
//#line 54 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.ir_fy = 100.0;
//#line 54 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.ir_fy = 500.0;
//#line 54 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.ir_fy = 390.0;
//#line 54 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      Depth_IR_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("ir_fy", "double", 0, "IR/Depth Camera Fy", "", &CISCameraConfig::ir_fy)));
//#line 54 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("ir_fy", "double", 0, "IR/Depth Camera Fy", "", &CISCameraConfig::ir_fy)));
//#line 55 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.ir_cx = 100.0;
//#line 55 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.ir_cx = 500.0;
//#line 55 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.ir_cx = 335.0;
//#line 55 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      Depth_IR_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("ir_cx", "double", 0, "IR/Depth Camera Cx", "", &CISCameraConfig::ir_cx)));
//#line 55 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("ir_cx", "double", 0, "IR/Depth Camera Cx", "", &CISCameraConfig::ir_cx)));
//#line 56 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.ir_cy = 100.0;
//#line 56 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.ir_cy = 500.0;
//#line 56 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.ir_cy = 230.0;
//#line 56 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      Depth_IR_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("ir_cy", "double", 0, "IR/Depth Camera Cy", "", &CISCameraConfig::ir_cy)));
//#line 56 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("ir_cy", "double", 0, "IR/Depth Camera Cy", "", &CISCameraConfig::ir_cy)));
//#line 57 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.ir_k1 = -0.25;
//#line 57 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.ir_k1 = 0.25;
//#line 57 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.ir_k1 = -0.19;
//#line 57 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      Depth_IR_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("ir_k1", "double", 0, "IR/Depth Camera K1", "", &CISCameraConfig::ir_k1)));
//#line 57 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("ir_k1", "double", 0, "IR/Depth Camera K1", "", &CISCameraConfig::ir_k1)));
//#line 58 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.ir_k2 = -0.1;
//#line 58 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.ir_k2 = 0.1;
//#line 58 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.ir_k2 = 0.07;
//#line 58 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      Depth_IR_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("ir_k2", "double", 0, "IR/Depth Camera K2", "", &CISCameraConfig::ir_k2)));
//#line 58 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("ir_k2", "double", 0, "IR/Depth Camera K2", "", &CISCameraConfig::ir_k2)));
//#line 59 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.ir_k3 = -0.1;
//#line 59 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.ir_k3 = 0.1;
//#line 59 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.ir_k3 = 0.005;
//#line 59 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      Depth_IR_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("ir_k3", "double", 0, "IR/Depth Camera K3", "", &CISCameraConfig::ir_k3)));
//#line 59 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("ir_k3", "double", 0, "IR/Depth Camera K3", "", &CISCameraConfig::ir_k3)));
//#line 60 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.ir_p1 = -0.05;
//#line 60 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.ir_p1 = 0.05;
//#line 60 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.ir_p1 = 0.0001;
//#line 60 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      Depth_IR_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("ir_p1", "double", 0, "IR/Depth Camera P1", "", &CISCameraConfig::ir_p1)));
//#line 60 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("ir_p1", "double", 0, "IR/Depth Camera P1", "", &CISCameraConfig::ir_p1)));
//#line 61 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.ir_p2 = -0.05;
//#line 61 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.ir_p2 = 0.05;
//#line 61 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.ir_p2 = 0.0005;
//#line 61 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      Depth_IR_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("ir_p2", "double", 0, "IR/Depth Camera P2", "", &CISCameraConfig::ir_p2)));
//#line 61 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("ir_p2", "double", 0, "IR/Depth Camera P2", "", &CISCameraConfig::ir_p2)));
//#line 124 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Depth_IR_Camera_Distortion_Correction_on_Driver_Software.convertParams();
//#line 124 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.groups.push_back(CISCameraConfig::AbstractGroupDescriptionConstPtr(new CISCameraConfig::GroupDescription<CISCameraConfig::DEFAULT::DEPTH_IR_CAMERA_DISTORTION_CORRECTION_ON_DRIVER_SOFTWARE, CISCameraConfig::DEFAULT>(Depth_IR_Camera_Distortion_Correction_on_Driver_Software)));
//#line 124 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(CISCameraConfig::AbstractGroupDescriptionConstPtr(new CISCameraConfig::GroupDescription<CISCameraConfig::DEFAULT::DEPTH_IR_CAMERA_DISTORTION_CORRECTION_ON_DRIVER_SOFTWARE, CISCameraConfig::DEFAULT>(Depth_IR_Camera_Distortion_Correction_on_Driver_Software)));
CISCameraConfig::GroupDescription<CISCameraConfig::DEFAULT::RGB_CAMERA_COLOR_GAINS_ON_DRIVER_SOFTWARE, CISCameraConfig::DEFAULT> RGB_Camera_Color_Gains_on_Driver_Software("RGB_Camera_Color_Gains_on_Driver_Software", "", 0, 4, true, &CISCameraConfig::DEFAULT::rgb_camera_color_gains_on_driver_software);
//#line 64 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.r_gain = 0.0;
//#line 64 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.r_gain = 1.0;
//#line 64 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.r_gain = 1.0;
//#line 64 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      RGB_Camera_Color_Gains_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("r_gain", "double", 0, "Red Gain", "", &CISCameraConfig::r_gain)));
//#line 64 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("r_gain", "double", 0, "Red Gain", "", &CISCameraConfig::r_gain)));
//#line 65 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.g_gain = 0.0;
//#line 65 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.g_gain = 1.0;
//#line 65 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.g_gain = 1.0;
//#line 65 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      RGB_Camera_Color_Gains_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("g_gain", "double", 0, "Green Gain", "", &CISCameraConfig::g_gain)));
//#line 65 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("g_gain", "double", 0, "Green Gain", "", &CISCameraConfig::g_gain)));
//#line 66 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.b_gain = 0.0;
//#line 66 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.b_gain = 1.0;
//#line 66 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.b_gain = 1.0;
//#line 66 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      RGB_Camera_Color_Gains_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("b_gain", "double", 0, "Blue Gain", "", &CISCameraConfig::b_gain)));
//#line 66 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("b_gain", "double", 0, "Blue Gain", "", &CISCameraConfig::b_gain)));
//#line 124 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      RGB_Camera_Color_Gains_on_Driver_Software.convertParams();
//#line 124 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.groups.push_back(CISCameraConfig::AbstractGroupDescriptionConstPtr(new CISCameraConfig::GroupDescription<CISCameraConfig::DEFAULT::RGB_CAMERA_COLOR_GAINS_ON_DRIVER_SOFTWARE, CISCameraConfig::DEFAULT>(RGB_Camera_Color_Gains_on_Driver_Software)));
//#line 124 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(CISCameraConfig::AbstractGroupDescriptionConstPtr(new CISCameraConfig::GroupDescription<CISCameraConfig::DEFAULT::RGB_CAMERA_COLOR_GAINS_ON_DRIVER_SOFTWARE, CISCameraConfig::DEFAULT>(RGB_Camera_Color_Gains_on_Driver_Software)));
CISCameraConfig::GroupDescription<CISCameraConfig::DEFAULT::RGB_CAMERA_DISTORTION_CORRECTION_ON_DRIVER_SOFTWARE, CISCameraConfig::DEFAULT> RGB_Camera_Distortion_Correction_on_Driver_Software("RGB_Camera_Distortion_Correction_on_Driver_Software", "", 0, 5, true, &CISCameraConfig::DEFAULT::rgb_camera_distortion_correction_on_driver_software);
//#line 69 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.rgb_dist_reconfig = 0;
//#line 69 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.rgb_dist_reconfig = 1;
//#line 69 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.rgb_dist_reconfig = 0;
//#line 69 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      RGB_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<bool>("rgb_dist_reconfig", "bool", 0, "RGB Camera Distortion Correction Reconfigure", "", &CISCameraConfig::rgb_dist_reconfig)));
//#line 69 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<bool>("rgb_dist_reconfig", "bool", 0, "RGB Camera Distortion Correction Reconfigure", "", &CISCameraConfig::rgb_dist_reconfig)));
//#line 70 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.rgb_fx = 100.0;
//#line 70 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.rgb_fx = 900.0;
//#line 70 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.rgb_fx = 775.3;
//#line 70 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      RGB_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("rgb_fx", "double", 0, "RGB Camera Fx", "", &CISCameraConfig::rgb_fx)));
//#line 70 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("rgb_fx", "double", 0, "RGB Camera Fx", "", &CISCameraConfig::rgb_fx)));
//#line 71 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.rgb_fy = 100.0;
//#line 71 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.rgb_fy = 900.0;
//#line 71 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.rgb_fy = 773.5;
//#line 71 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      RGB_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("rgb_fy", "double", 0, "RGB Camera Fy", "", &CISCameraConfig::rgb_fy)));
//#line 71 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("rgb_fy", "double", 0, "RGB Camera Fy", "", &CISCameraConfig::rgb_fy)));
//#line 72 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.rgb_cx = 100.0;
//#line 72 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.rgb_cx = 900.0;
//#line 72 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.rgb_cx = 620.0;
//#line 72 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      RGB_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("rgb_cx", "double", 0, "RGB Camera Cx", "", &CISCameraConfig::rgb_cx)));
//#line 72 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("rgb_cx", "double", 0, "RGB Camera Cx", "", &CISCameraConfig::rgb_cx)));
//#line 73 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.rgb_cy = 100.0;
//#line 73 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.rgb_cy = 900.0;
//#line 73 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.rgb_cy = 480.0;
//#line 73 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      RGB_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("rgb_cy", "double", 0, "RGB Camera Cy", "", &CISCameraConfig::rgb_cy)));
//#line 73 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("rgb_cy", "double", 0, "RGB Camera Cy", "", &CISCameraConfig::rgb_cy)));
//#line 74 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.rgb_k1 = -0.5;
//#line 74 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.rgb_k1 = 0.5;
//#line 74 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.rgb_k1 = -0.3404;
//#line 74 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      RGB_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("rgb_k1", "double", 0, "RGB Camera K1", "", &CISCameraConfig::rgb_k1)));
//#line 74 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("rgb_k1", "double", 0, "RGB Camera K1", "", &CISCameraConfig::rgb_k1)));
//#line 75 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.rgb_k2 = -0.2;
//#line 75 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.rgb_k2 = 0.2;
//#line 75 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.rgb_k2 = 0.146;
//#line 75 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      RGB_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("rgb_k2", "double", 0, "RGB Camera K2", "", &CISCameraConfig::rgb_k2)));
//#line 75 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("rgb_k2", "double", 0, "RGB Camera K2", "", &CISCameraConfig::rgb_k2)));
//#line 76 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.rgb_k3 = -0.1;
//#line 76 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.rgb_k3 = 0.1;
//#line 76 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.rgb_k3 = -0.0314;
//#line 76 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      RGB_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("rgb_k3", "double", 0, "RGB Camera K3", "", &CISCameraConfig::rgb_k3)));
//#line 76 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("rgb_k3", "double", 0, "RGB Camera K3", "", &CISCameraConfig::rgb_k3)));
//#line 77 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.rgb_p1 = -0.05;
//#line 77 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.rgb_p1 = 0.05;
//#line 77 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.rgb_p1 = 0.0005;
//#line 77 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      RGB_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("rgb_p1", "double", 0, "RGB Camera P1", "", &CISCameraConfig::rgb_p1)));
//#line 77 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("rgb_p1", "double", 0, "RGB Camera P1", "", &CISCameraConfig::rgb_p1)));
//#line 78 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __min__.rgb_p2 = -0.05;
//#line 78 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __max__.rgb_p2 = 0.05;
//#line 78 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __default__.rgb_p2 = 0.0001;
//#line 78 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      RGB_Camera_Distortion_Correction_on_Driver_Software.abstract_parameters.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("rgb_p2", "double", 0, "RGB Camera P2", "", &CISCameraConfig::rgb_p2)));
//#line 78 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      __param_descriptions__.push_back(CISCameraConfig::AbstractParamDescriptionConstPtr(new CISCameraConfig::ParamDescription<double>("rgb_p2", "double", 0, "RGB Camera P2", "", &CISCameraConfig::rgb_p2)));
//#line 124 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      RGB_Camera_Distortion_Correction_on_Driver_Software.convertParams();
//#line 124 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.groups.push_back(CISCameraConfig::AbstractGroupDescriptionConstPtr(new CISCameraConfig::GroupDescription<CISCameraConfig::DEFAULT::RGB_CAMERA_DISTORTION_CORRECTION_ON_DRIVER_SOFTWARE, CISCameraConfig::DEFAULT>(RGB_Camera_Distortion_Correction_on_Driver_Software)));
//#line 124 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(CISCameraConfig::AbstractGroupDescriptionConstPtr(new CISCameraConfig::GroupDescription<CISCameraConfig::DEFAULT::RGB_CAMERA_DISTORTION_CORRECTION_ON_DRIVER_SOFTWARE, CISCameraConfig::DEFAULT>(RGB_Camera_Distortion_Correction_on_Driver_Software)));
//#line 245 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.convertParams();
//#line 245 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(CISCameraConfig::AbstractGroupDescriptionConstPtr(new CISCameraConfig::GroupDescription<CISCameraConfig::DEFAULT, CISCameraConfig>(Default)));
//#line 366 "/opt/ros/kinetic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

      for (std::vector<CISCameraConfig::AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        __description_message__.groups.push_back(**i);
      }
      __max__.__toMessage__(__description_message__.max, __param_descriptions__, __group_descriptions__);
      __min__.__toMessage__(__description_message__.min, __param_descriptions__, __group_descriptions__);
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__, __group_descriptions__);
    }
    std::vector<CISCameraConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    std::vector<CISCameraConfig::AbstractGroupDescriptionConstPtr> __group_descriptions__;
    CISCameraConfig __max__;
    CISCameraConfig __min__;
    CISCameraConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;

    static const CISCameraConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static CISCameraConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &CISCameraConfig::__getDescriptionMessage__()
  {
    return __get_statics__()->__description_message__;
  }

  inline const CISCameraConfig &CISCameraConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }

  inline const CISCameraConfig &CISCameraConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }

  inline const CISCameraConfig &CISCameraConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }

  inline const std::vector<CISCameraConfig::AbstractParamDescriptionConstPtr> &CISCameraConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const std::vector<CISCameraConfig::AbstractGroupDescriptionConstPtr> &CISCameraConfig::__getGroupDescriptions__()
  {
    return __get_statics__()->__group_descriptions__;
  }

  inline const CISCameraConfigStatics *CISCameraConfig::__get_statics__()
  {
    const static CISCameraConfigStatics *statics;

    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = CISCameraConfigStatics::get_instance();

    return statics;
  }

//#line 13 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      const int CISCamera_Range_0 = 0;
//#line 14 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      const int CISCamera_Range_1 = 1;
//#line 19 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      const int CISCamera_NR_Off = 0;
//#line 20 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      const int CISCamera_NR_On = 1;
//#line 34 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      const int CISCamera_Manual = 0;
//#line 35 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      const int CISCamera_Auto_Gain = 1;
//#line 36 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      const int CISCamera_Auto_Shutter = 2;
//#line 37 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      const int CISCamera_Auto_Full = 3;
//#line 41 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      const int CISCamera_Off = 0;
//#line 42 "/tmp/binarydeb/ros-kinetic-cis-camera-0.0.4/cfg/CISCamera.cfg"
      const int CISCamera_Standard = 1;
}

#undef DYNAMIC_RECONFIGURE_FINAL

#endif // __CISCAMERARECONFIGURATOR_H__
